/* WallpaperWindow.c generated by valac 0.56.18, the Vala compiler
 * generated from WallpaperWindow.vala, do not modify */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <adwaita.h>
#include <gsk/gsk.h>
#include <gdk/gdk.h>
#include <gtk4-layer-shell.h>
#include <string.h>
#include <graphene-gobject.h>
#include <stdlib.h>

#define WALLPAPER_WINDOW_SCALING_FILTER GSK_SCALING_FILTER_NEAREST
#define WALLPAPER_WINDOW_TRANSITION_DURATION 500
#define WALLPAPER_WINDOW_BLUR_RADIUS 100
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WALLPAPER_TYPE_WINDOW (wallpaper_window_get_type ())
#define WALLPAPER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WALLPAPER_TYPE_WINDOW, WallpaperWindow))
#define WALLPAPER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WALLPAPER_TYPE_WINDOW, WallpaperWindowClass))
#define WALLPAPER_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WALLPAPER_TYPE_WINDOW))
#define WALLPAPER_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WALLPAPER_TYPE_WINDOW))
#define WALLPAPER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WALLPAPER_TYPE_WINDOW, WallpaperWindowClass))

typedef struct _WallpaperWindow WallpaperWindow;
typedef struct _WallpaperWindowClass WallpaperWindowClass;
typedef struct _WallpaperWindowPrivate WallpaperWindowPrivate;
enum  {
	WALLPAPER_WINDOW_0_PROPERTY,
	WALLPAPER_WINDOW_NUM_PROPERTIES
};
static GParamSpec* wallpaper_window_properties[WALLPAPER_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define WALLPAPER_TYPE_BACKGROUND_INFO (wallpaper_background_info_get_type ())
typedef struct _WallpaperBackgroundInfo WallpaperBackgroundInfo;

#define UTILS_TYPE_CONFIG (utils_config_get_type ())
typedef struct _UtilsConfig UtilsConfig;
typedef enum  {
	UTILS_SCALE_MODES_FILL = 0,
	UTILS_SCALE_MODES_STRETCH = 1,
	UTILS_SCALE_MODES_FIT = 2,
	UTILS_SCALE_MODES_CENTER = 3
} UtilsScaleModes;

#define UTILS_TYPE_SCALE_MODES (utils_scale_modes_get_type ())

struct _WallpaperWindow {
	GtkWindow parent_instance;
	WallpaperWindowPrivate * priv;
};

struct _WallpaperWindowClass {
	GtkWindowClass parent_class;
};

struct _WallpaperWindowPrivate {
	gdouble animation_progress;
	AdwTimedAnimation* animation;
};

struct _UtilsConfig {
	gchar* path;
	UtilsScaleModes scale_mode;
	gchar* color;
};

struct _WallpaperBackgroundInfo {
	UtilsConfig config;
	GdkTexture* texture;
	gint width;
	gint height;
};

static gint WallpaperWindow_private_offset;
static gpointer wallpaper_window_parent_class = NULL;
VALA_EXTERN WallpaperBackgroundInfo wallpaper_old_background_info;
VALA_EXTERN WallpaperBackgroundInfo wallpaper_background_info;

VALA_EXTERN GType wallpaper_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WallpaperWindow, g_object_unref)
VALA_EXTERN WallpaperWindow* wallpaper_window_new (GtkApplication* app,
                                       GdkMonitor* monitor);
VALA_EXTERN WallpaperWindow* wallpaper_window_construct (GType object_type,
                                             GtkApplication* app,
                                             GdkMonitor* monitor);
static void wallpaper_window_animation_value_cb (WallpaperWindow* self,
                                          gdouble progress);
static void _wallpaper_window_animation_value_cb_adw_animation_target_func (gdouble value,
                                                                     gpointer self);
VALA_EXTERN void wallpaper_window_change_wallpaper (WallpaperWindow* self);
static void wallpaper_window_real_snapshot (GtkWidget* base,
                                     GtkSnapshot* snapshot);
static gdouble wallpaper_window_get_animation_progress_inv (WallpaperWindow* self);
VALA_EXTERN GType wallpaper_background_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType utils_config_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType utils_scale_modes_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UtilsConfig* utils_config_dup (const UtilsConfig* self);
VALA_EXTERN void utils_config_free (UtilsConfig* self);
VALA_EXTERN void utils_config_copy (const UtilsConfig* self,
                        UtilsConfig* dest);
VALA_EXTERN void utils_config_destroy (UtilsConfig* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (UtilsConfig, utils_config_destroy)
VALA_EXTERN WallpaperBackgroundInfo* wallpaper_background_info_dup (const WallpaperBackgroundInfo* self);
VALA_EXTERN void wallpaper_background_info_free (WallpaperBackgroundInfo* self);
VALA_EXTERN void wallpaper_background_info_copy (const WallpaperBackgroundInfo* self,
                                     WallpaperBackgroundInfo* dest);
VALA_EXTERN void wallpaper_background_info_destroy (WallpaperBackgroundInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (WallpaperBackgroundInfo, wallpaper_background_info_destroy)
static void wallpaper_window_apply_transformed_background (WallpaperWindow* self,
                                                    GtkSnapshot* snapshot,
                                                    WallpaperBackgroundInfo* info);
VALA_EXTERN void utils_config_get_color (UtilsConfig *self,
                             GdkRGBA* result);
static void wallpaper_window_draw_scale_wide (WallpaperWindow* self,
                                       gint buffer_width,
                                       gint width,
                                       gint buffer_height,
                                       gint height,
                                       GtkSnapshot* snapshot,
                                       WallpaperBackgroundInfo* info);
static void wallpaper_window_draw_scale_tall (WallpaperWindow* self,
                                       gint buffer_width,
                                       gint width,
                                       gint buffer_height,
                                       gint height,
                                       GtkSnapshot* snapshot,
                                       WallpaperBackgroundInfo* info);
static void wallpaper_window_finalize (GObject * obj);
static GType wallpaper_window_get_type_once (void);
static void _vala_wallpaper_window_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
wallpaper_window_get_instance_private (WallpaperWindow* self)
{
	return G_STRUCT_MEMBER_P (self, WallpaperWindow_private_offset);
}

static void
_wallpaper_window_animation_value_cb_adw_animation_target_func (gdouble value,
                                                                gpointer self)
{
#line 18 "../src/Wallpaper/WallpaperWindow.vala"
	wallpaper_window_animation_value_cb ((WallpaperWindow*) self, value);
#line 170 "WallpaperWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 19 "../src/Wallpaper/WallpaperWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 178 "WallpaperWindow.c"
}

WallpaperWindow*
wallpaper_window_construct (GType object_type,
                            GtkApplication* app,
                            GdkMonitor* monitor)
{
	WallpaperWindow * self = NULL;
	AdwCallbackAnimationTarget* target = NULL;
	AdwCallbackAnimationTarget* _tmp0_;
	AdwAnimationTarget* _tmp1_;
	AdwTimedAnimation* _tmp2_;
#line 15 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 15 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_val_if_fail (monitor != NULL, NULL);
#line 16 "../src/Wallpaper/WallpaperWindow.vala"
	self = (WallpaperWindow*) g_object_new (object_type, "application", app, NULL);
#line 18 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_ = (AdwCallbackAnimationTarget*) adw_callback_animation_target_new (_wallpaper_window_animation_value_cb_adw_animation_target_func, g_object_ref (self), g_object_unref);
#line 18 "../src/Wallpaper/WallpaperWindow.vala"
	target = _tmp0_;
#line 19 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp1_ = _g_object_ref0 ((AdwAnimationTarget*) target);
#line 19 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_ = (AdwTimedAnimation*) adw_timed_animation_new ((GtkWidget*) self, 1.0, 0.0, (guint) WALLPAPER_WINDOW_TRANSITION_DURATION, _tmp1_);
#line 19 "../src/Wallpaper/WallpaperWindow.vala"
	_g_object_unref0 (self->priv->animation);
#line 19 "../src/Wallpaper/WallpaperWindow.vala"
	self->priv->animation = _tmp2_;
#line 21 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_init_for_window ((GtkWindow*) self);
#line 22 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_set_monitor ((GtkWindow*) self, monitor);
#line 23 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_set_layer ((GtkWindow*) self, GTK_LAYER_SHELL_LAYER_BACKGROUND);
#line 24 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_set_exclusive_zone ((GtkWindow*) self, -1);
#line 25 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_set_anchor ((GtkWindow*) self, GTK_LAYER_SHELL_EDGE_TOP, TRUE);
#line 26 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_set_anchor ((GtkWindow*) self, GTK_LAYER_SHELL_EDGE_BOTTOM, TRUE);
#line 27 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_set_anchor ((GtkWindow*) self, GTK_LAYER_SHELL_EDGE_LEFT, TRUE);
#line 28 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_layer_set_anchor ((GtkWindow*) self, GTK_LAYER_SHELL_EDGE_RIGHT, TRUE);
#line 30 "../src/Wallpaper/WallpaperWindow.vala"
	wallpaper_window_change_wallpaper (self);
#line 15 "../src/Wallpaper/WallpaperWindow.vala"
	_g_object_unref0 (target);
#line 15 "../src/Wallpaper/WallpaperWindow.vala"
	return self;
#line 231 "WallpaperWindow.c"
}

WallpaperWindow*
wallpaper_window_new (GtkApplication* app,
                      GdkMonitor* monitor)
{
#line 15 "../src/Wallpaper/WallpaperWindow.vala"
	return wallpaper_window_construct (WALLPAPER_TYPE_WINDOW, app, monitor);
#line 240 "WallpaperWindow.c"
}

void
wallpaper_window_change_wallpaper (WallpaperWindow* self)
{
	AdwTimedAnimation* _tmp0_;
	AdwTimedAnimation* _tmp1_;
#line 33 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_ = self->priv->animation;
#line 35 "../src/Wallpaper/WallpaperWindow.vala"
	adw_timed_animation_set_value_to (_tmp0_, (gdouble) 0);
#line 36 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp1_ = self->priv->animation;
#line 36 "../src/Wallpaper/WallpaperWindow.vala"
	adw_animation_play ((AdwAnimation*) _tmp1_);
#line 258 "WallpaperWindow.c"
}

static void
wallpaper_window_real_snapshot (GtkWidget* base,
                                GtkSnapshot* snapshot)
{
	WallpaperWindow * self;
	GdkRGBA bg_color = {0};
	GdkRGBA _tmp0_ = {0};
	GdkRGBA _tmp1_;
	graphene_rect_t _tmp2_ = {0};
	AdwTimedAnimation* _tmp3_;
	AdwAnimationState _tmp4_;
	AdwAnimationState _tmp5_;
#line 39 "../src/Wallpaper/WallpaperWindow.vala"
	self = (WallpaperWindow*) base;
#line 39 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (snapshot != NULL);
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
	memset (&_tmp0_, 0, sizeof (GdkRGBA));
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_.red = 0.0f;
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_.green = 0.0f;
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_.blue = 0.0f;
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_.alpha = 1.0f;
#line 41 "../src/Wallpaper/WallpaperWindow.vala"
	bg_color = _tmp0_;
#line 48 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp1_ = bg_color;
#line 48 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_.origin = (graphene_point_t) {(gfloat) 0, (gfloat) 0};
#line 48 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_.size = (graphene_size_t) {(gfloat) gtk_widget_get_width ((GtkWidget*) self), (gfloat) gtk_widget_get_height ((GtkWidget*) self)};
#line 48 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_snapshot_append_color (snapshot, &_tmp1_, &_tmp2_);
#line 49 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp3_ = self->priv->animation;
#line 49 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp4_ = adw_animation_get_state ((AdwAnimation*) _tmp3_);
#line 49 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp5_ = _tmp4_;
#line 49 "../src/Wallpaper/WallpaperWindow.vala"
	if (_tmp5_ == ADW_ANIMATION_PLAYING) {
#line 305 "WallpaperWindow.c"
		gdouble _tmp6_;
		gdouble _tmp7_;
		WallpaperBackgroundInfo _tmp8_;
		WallpaperBackgroundInfo _tmp9_;
#line 50 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp6_ = wallpaper_window_get_animation_progress_inv (self);
#line 50 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp7_ = _tmp6_;
#line 50 "../src/Wallpaper/WallpaperWindow.vala"
		gtk_snapshot_push_cross_fade (snapshot, _tmp7_);
#line 52 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp8_ = wallpaper_old_background_info;
#line 52 "../src/Wallpaper/WallpaperWindow.vala"
		wallpaper_window_apply_transformed_background (self, snapshot, &_tmp8_);
#line 53 "../src/Wallpaper/WallpaperWindow.vala"
		gtk_snapshot_pop (snapshot);
#line 55 "../src/Wallpaper/WallpaperWindow.vala"
		gtk_snapshot_push_blur (snapshot, self->priv->animation_progress * WALLPAPER_WINDOW_BLUR_RADIUS);
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp9_ = wallpaper_background_info;
#line 56 "../src/Wallpaper/WallpaperWindow.vala"
		wallpaper_window_apply_transformed_background (self, snapshot, &_tmp9_);
#line 57 "../src/Wallpaper/WallpaperWindow.vala"
		gtk_snapshot_pop (snapshot);
#line 58 "../src/Wallpaper/WallpaperWindow.vala"
		gtk_snapshot_pop (snapshot);
#line 332 "WallpaperWindow.c"
	} else {
		WallpaperBackgroundInfo _tmp10_;
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp10_ = wallpaper_background_info;
#line 60 "../src/Wallpaper/WallpaperWindow.vala"
		wallpaper_window_apply_transformed_background (self, snapshot, &_tmp10_);
#line 339 "WallpaperWindow.c"
	}
}

static void
wallpaper_window_apply_transformed_background (WallpaperWindow* self,
                                               GtkSnapshot* snapshot,
                                               WallpaperBackgroundInfo* info)
{
	gint buffer_height = 0;
	gint buffer_width = 0;
	gboolean _tmp0_ = FALSE;
	WallpaperBackgroundInfo _tmp1_;
	GdkTexture* _tmp2_;
	gint height = 0;
	WallpaperBackgroundInfo _tmp11_;
	gint width = 0;
	WallpaperBackgroundInfo _tmp12_;
	WallpaperBackgroundInfo _tmp13_;
	UtilsConfig _tmp14_;
#line 64 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (snapshot != NULL);
#line 64 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (info != NULL);
#line 65 "../src/Wallpaper/WallpaperWindow.vala"
	buffer_height = gtk_widget_get_height ((GtkWidget*) self);
#line 66 "../src/Wallpaper/WallpaperWindow.vala"
	buffer_width = gtk_widget_get_width ((GtkWidget*) self);
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp1_ = *info;
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_ = _tmp1_.texture;
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
	if (_tmp2_ == NULL) {
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp0_ = TRUE;
#line 377 "WallpaperWindow.c"
	} else {
		WallpaperBackgroundInfo _tmp3_;
		UtilsConfig _tmp4_;
		const gchar* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp3_ = *info;
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp4_ = _tmp3_.config;
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp5_ = _tmp4_.path;
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp6_ = strlen (_tmp5_);
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp7_ = _tmp6_;
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp0_ = _tmp7_ == 0;
#line 396 "WallpaperWindow.c"
	}
#line 69 "../src/Wallpaper/WallpaperWindow.vala"
	if (_tmp0_) {
#line 400 "WallpaperWindow.c"
		GdkRGBA color = {0};
		GdkRGBA _tmp8_ = {0};
		GdkRGBA _tmp9_;
		graphene_rect_t _tmp10_ = {0};
#line 70 "../src/Wallpaper/WallpaperWindow.vala"
		utils_config_get_color (&(*info).config, &_tmp8_);
#line 70 "../src/Wallpaper/WallpaperWindow.vala"
		color = _tmp8_;
#line 71 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp9_ = color;
#line 71 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp10_.origin = (graphene_point_t) {(gfloat) 0, (gfloat) 0};
#line 71 "../src/Wallpaper/WallpaperWindow.vala"
		_tmp10_.size = (graphene_size_t) {(gfloat) buffer_width, (gfloat) buffer_height};
#line 71 "../src/Wallpaper/WallpaperWindow.vala"
		gtk_snapshot_append_color (snapshot, &_tmp9_, &_tmp10_);
#line 72 "../src/Wallpaper/WallpaperWindow.vala"
		return;
#line 419 "WallpaperWindow.c"
	}
#line 76 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_snapshot_save (snapshot);
#line 78 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp11_ = *info;
#line 78 "../src/Wallpaper/WallpaperWindow.vala"
	height = _tmp11_.height;
#line 79 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp12_ = *info;
#line 79 "../src/Wallpaper/WallpaperWindow.vala"
	width = _tmp12_.width;
#line 80 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp13_ = *info;
#line 80 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp14_ = _tmp13_.config;
#line 80 "../src/Wallpaper/WallpaperWindow.vala"
	switch (_tmp14_.scale_mode) {
#line 80 "../src/Wallpaper/WallpaperWindow.vala"
		case UTILS_SCALE_MODES_FILL:
#line 439 "WallpaperWindow.c"
		{
			gdouble window_ratio = 0.0;
			gdouble bg_ratio = 0.0;
#line 82 "../src/Wallpaper/WallpaperWindow.vala"
			window_ratio = ((gdouble) buffer_width) / buffer_height;
#line 83 "../src/Wallpaper/WallpaperWindow.vala"
			bg_ratio = (gdouble) (width / height);
#line 84 "../src/Wallpaper/WallpaperWindow.vala"
			if (window_ratio > bg_ratio) {
#line 449 "WallpaperWindow.c"
				gdouble scale = 0.0;
#line 85 "../src/Wallpaper/WallpaperWindow.vala"
				scale = ((gdouble) buffer_width) / width;
#line 86 "../src/Wallpaper/WallpaperWindow.vala"
				if ((scale * height) < ((gdouble) buffer_height)) {
#line 455 "WallpaperWindow.c"
					WallpaperBackgroundInfo _tmp15_;
#line 87 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp15_ = *info;
#line 87 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_wide (self, buffer_width, width, buffer_height, height, snapshot, &_tmp15_);
#line 461 "WallpaperWindow.c"
				} else {
					WallpaperBackgroundInfo _tmp16_;
#line 89 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp16_ = *info;
#line 89 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_tall (self, buffer_width, width, buffer_height, height, snapshot, &_tmp16_);
#line 468 "WallpaperWindow.c"
				}
			} else {
				gdouble scale = 0.0;
#line 92 "../src/Wallpaper/WallpaperWindow.vala"
				scale = ((gdouble) buffer_height) / height;
#line 93 "../src/Wallpaper/WallpaperWindow.vala"
				if ((scale * width) < ((gdouble) buffer_width)) {
#line 476 "WallpaperWindow.c"
					WallpaperBackgroundInfo _tmp17_;
#line 94 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp17_ = *info;
#line 94 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_tall (self, buffer_width, width, buffer_height, height, snapshot, &_tmp17_);
#line 482 "WallpaperWindow.c"
				} else {
					WallpaperBackgroundInfo _tmp18_;
#line 96 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp18_ = *info;
#line 96 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_wide (self, buffer_width, width, buffer_height, height, snapshot, &_tmp18_);
#line 489 "WallpaperWindow.c"
				}
			}
#line 99 "../src/Wallpaper/WallpaperWindow.vala"
			break;
#line 494 "WallpaperWindow.c"
		}
#line 80 "../src/Wallpaper/WallpaperWindow.vala"
		case UTILS_SCALE_MODES_FIT:
#line 498 "WallpaperWindow.c"
		{
			gdouble window_ratio = 0.0;
			gdouble bg_ratio = 0.0;
#line 101 "../src/Wallpaper/WallpaperWindow.vala"
			window_ratio = ((gdouble) buffer_width) / buffer_height;
#line 102 "../src/Wallpaper/WallpaperWindow.vala"
			bg_ratio = (gdouble) (width / height);
#line 103 "../src/Wallpaper/WallpaperWindow.vala"
			if (window_ratio > bg_ratio) {
#line 508 "WallpaperWindow.c"
				gdouble scale = 0.0;
#line 104 "../src/Wallpaper/WallpaperWindow.vala"
				scale = ((gdouble) buffer_width) / width;
#line 105 "../src/Wallpaper/WallpaperWindow.vala"
				if ((scale * height) < ((gdouble) buffer_height)) {
#line 514 "WallpaperWindow.c"
					WallpaperBackgroundInfo _tmp19_;
#line 106 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp19_ = *info;
#line 106 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_tall (self, buffer_width, width, buffer_height, height, snapshot, &_tmp19_);
#line 520 "WallpaperWindow.c"
				} else {
					WallpaperBackgroundInfo _tmp20_;
#line 108 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp20_ = *info;
#line 108 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_wide (self, buffer_width, width, buffer_height, height, snapshot, &_tmp20_);
#line 527 "WallpaperWindow.c"
				}
			} else {
				gdouble scale = 0.0;
#line 111 "../src/Wallpaper/WallpaperWindow.vala"
				scale = ((gdouble) buffer_height) / height;
#line 112 "../src/Wallpaper/WallpaperWindow.vala"
				if ((scale * width) < ((gdouble) buffer_width)) {
#line 535 "WallpaperWindow.c"
					WallpaperBackgroundInfo _tmp21_;
#line 113 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp21_ = *info;
#line 113 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_wide (self, buffer_width, width, buffer_height, height, snapshot, &_tmp21_);
#line 541 "WallpaperWindow.c"
				} else {
					WallpaperBackgroundInfo _tmp22_;
#line 115 "../src/Wallpaper/WallpaperWindow.vala"
					_tmp22_ = *info;
#line 115 "../src/Wallpaper/WallpaperWindow.vala"
					wallpaper_window_draw_scale_tall (self, buffer_width, width, buffer_height, height, snapshot, &_tmp22_);
#line 548 "WallpaperWindow.c"
				}
			}
#line 118 "../src/Wallpaper/WallpaperWindow.vala"
			break;
#line 553 "WallpaperWindow.c"
		}
#line 80 "../src/Wallpaper/WallpaperWindow.vala"
		case UTILS_SCALE_MODES_STRETCH:
#line 557 "WallpaperWindow.c"
		{
			WallpaperBackgroundInfo _tmp23_;
			GdkTexture* _tmp24_;
			graphene_rect_t _tmp25_ = {0};
#line 120 "../src/Wallpaper/WallpaperWindow.vala"
			gtk_snapshot_scale (snapshot, ((gfloat) buffer_width) / width, ((gfloat) buffer_height) / height);
#line 122 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp23_ = *info;
#line 122 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp24_ = _tmp23_.texture;
#line 122 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp25_.origin = (graphene_point_t) {(gfloat) 0, (gfloat) 0};
#line 122 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp25_.size = (graphene_size_t) {(gfloat) width, (gfloat) height};
#line 122 "../src/Wallpaper/WallpaperWindow.vala"
			gtk_snapshot_append_scaled_texture (snapshot, _tmp24_, WALLPAPER_WINDOW_SCALING_FILTER, &_tmp25_);
#line 125 "../src/Wallpaper/WallpaperWindow.vala"
			break;
#line 576 "WallpaperWindow.c"
		}
#line 80 "../src/Wallpaper/WallpaperWindow.vala"
		case UTILS_SCALE_MODES_CENTER:
#line 580 "WallpaperWindow.c"
		{
			gfloat x = 0.0F;
			gfloat y = 0.0F;
			WallpaperBackgroundInfo _tmp26_;
			GdkTexture* _tmp27_;
			graphene_rect_t _tmp28_ = {0};
#line 127 "../src/Wallpaper/WallpaperWindow.vala"
			x = (gfloat) ((buffer_width / 2) - (width / 2));
#line 128 "../src/Wallpaper/WallpaperWindow.vala"
			y = (gfloat) ((buffer_height / 2) - (height / 2));
#line 129 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp26_ = *info;
#line 129 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp27_ = _tmp26_.texture;
#line 129 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp28_.origin = (graphene_point_t) {x, y};
#line 129 "../src/Wallpaper/WallpaperWindow.vala"
			_tmp28_.size = (graphene_size_t) {(gfloat) width, (gfloat) height};
#line 129 "../src/Wallpaper/WallpaperWindow.vala"
			gtk_snapshot_append_scaled_texture (snapshot, _tmp27_, WALLPAPER_WINDOW_SCALING_FILTER, &_tmp28_);
#line 132 "../src/Wallpaper/WallpaperWindow.vala"
			break;
#line 603 "WallpaperWindow.c"
		}
		default:
#line 80 "../src/Wallpaper/WallpaperWindow.vala"
		break;
#line 608 "WallpaperWindow.c"
	}
#line 134 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_snapshot_restore (snapshot);
#line 612 "WallpaperWindow.c"
}

static void
wallpaper_window_draw_scale_tall (WallpaperWindow* self,
                                  gint buffer_width,
                                  gint width,
                                  gint buffer_height,
                                  gint height,
                                  GtkSnapshot* snapshot,
                                  WallpaperBackgroundInfo* info)
{
	gfloat scale = 0.0F;
	gfloat x = 0.0F;
	gfloat y = 0.0F;
	WallpaperBackgroundInfo _tmp0_;
	GdkTexture* _tmp1_;
	graphene_rect_t _tmp2_ = {0};
#line 137 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (snapshot != NULL);
#line 137 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (info != NULL);
#line 143 "../src/Wallpaper/WallpaperWindow.vala"
	scale = ((gfloat) buffer_width) / width;
#line 144 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_snapshot_scale (snapshot, scale, scale);
#line 145 "../src/Wallpaper/WallpaperWindow.vala"
	x = (gfloat) 0;
#line 146 "../src/Wallpaper/WallpaperWindow.vala"
	y = (gfloat) (((buffer_height / 2) / scale) - (height / 2));
#line 147 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_ = *info;
#line 147 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp1_ = _tmp0_.texture;
#line 147 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_.origin = (graphene_point_t) {x, y};
#line 147 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_.size = (graphene_size_t) {(gfloat) width, (gfloat) height};
#line 147 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_snapshot_append_scaled_texture (snapshot, _tmp1_, WALLPAPER_WINDOW_SCALING_FILTER, &_tmp2_);
#line 654 "WallpaperWindow.c"
}

static void
wallpaper_window_draw_scale_wide (WallpaperWindow* self,
                                  gint buffer_width,
                                  gint width,
                                  gint buffer_height,
                                  gint height,
                                  GtkSnapshot* snapshot,
                                  WallpaperBackgroundInfo* info)
{
	gfloat scale = 0.0F;
	gfloat x = 0.0F;
	gfloat y = 0.0F;
	WallpaperBackgroundInfo _tmp0_;
	GdkTexture* _tmp1_;
	graphene_rect_t _tmp2_ = {0};
#line 152 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (snapshot != NULL);
#line 152 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (info != NULL);
#line 158 "../src/Wallpaper/WallpaperWindow.vala"
	scale = ((gfloat) buffer_height) / height;
#line 159 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_snapshot_scale (snapshot, scale, scale);
#line 160 "../src/Wallpaper/WallpaperWindow.vala"
	x = (gfloat) (((buffer_width / 2) / scale) - (width / 2));
#line 161 "../src/Wallpaper/WallpaperWindow.vala"
	y = (gfloat) 0;
#line 162 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp0_ = *info;
#line 162 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp1_ = _tmp0_.texture;
#line 162 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_.origin = (graphene_point_t) {x, y};
#line 162 "../src/Wallpaper/WallpaperWindow.vala"
	_tmp2_.size = (graphene_size_t) {(gfloat) width, (gfloat) height};
#line 162 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_snapshot_append_scaled_texture (snapshot, _tmp1_, WALLPAPER_WINDOW_SCALING_FILTER, &_tmp2_);
#line 696 "WallpaperWindow.c"
}

static void
wallpaper_window_animation_value_cb (WallpaperWindow* self,
                                     gdouble progress)
{
#line 167 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/Wallpaper/WallpaperWindow.vala"
	self->priv->animation_progress = progress;
#line 170 "../src/Wallpaper/WallpaperWindow.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 709 "WallpaperWindow.c"
}

static gdouble
wallpaper_window_get_animation_progress_inv (WallpaperWindow* self)
{
	gdouble result;
#line 9 "../src/Wallpaper/WallpaperWindow.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 10 "../src/Wallpaper/WallpaperWindow.vala"
	result = 1 - self->priv->animation_progress;
#line 10 "../src/Wallpaper/WallpaperWindow.vala"
	return result;
#line 722 "WallpaperWindow.c"
}

static void
wallpaper_window_class_init (WallpaperWindowClass * klass,
                             gpointer klass_data)
{
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	wallpaper_window_parent_class = g_type_class_peek_parent (klass);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	g_type_class_adjust_private_offset (klass, &WallpaperWindow_private_offset);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	((GtkWidgetClass *) klass)->snapshot = (void (*) (GtkWidget*, GtkSnapshot*)) wallpaper_window_real_snapshot;
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_wallpaper_window_get_property;
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = wallpaper_window_finalize;
#line 739 "WallpaperWindow.c"
}

static void
wallpaper_window_instance_init (WallpaperWindow * self,
                                gpointer klass)
{
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	self->priv = wallpaper_window_get_instance_private (self);
#line 7 "../src/Wallpaper/WallpaperWindow.vala"
	self->priv->animation_progress = 1.0;
#line 750 "WallpaperWindow.c"
}

static void
wallpaper_window_finalize (GObject * obj)
{
	WallpaperWindow * self;
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLPAPER_TYPE_WINDOW, WallpaperWindow);
#line 13 "../src/Wallpaper/WallpaperWindow.vala"
	_g_object_unref0 (self->priv->animation);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	G_OBJECT_CLASS (wallpaper_window_parent_class)->finalize (obj);
#line 763 "WallpaperWindow.c"
}

static GType
wallpaper_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WallpaperWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wallpaper_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WallpaperWindow), 0, (GInstanceInitFunc) wallpaper_window_instance_init, NULL };
	GType wallpaper_window_type_id;
	wallpaper_window_type_id = g_type_register_static (gtk_window_get_type (), "WallpaperWindow", &g_define_type_info, 0);
	WallpaperWindow_private_offset = g_type_add_instance_private (wallpaper_window_type_id, sizeof (WallpaperWindowPrivate));
	return wallpaper_window_type_id;
}

GType
wallpaper_window_get_type (void)
{
	static volatile gsize wallpaper_window_type_id__once = 0;
	if (g_once_init_enter (&wallpaper_window_type_id__once)) {
		GType wallpaper_window_type_id;
		wallpaper_window_type_id = wallpaper_window_get_type_once ();
		g_once_init_leave (&wallpaper_window_type_id__once, wallpaper_window_type_id);
	}
	return wallpaper_window_type_id__once;
}

static void
_vala_wallpaper_window_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	WallpaperWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLPAPER_TYPE_WINDOW, WallpaperWindow);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
	switch (property_id) {
#line 798 "WallpaperWindow.c"
		default:
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 2 "../src/Wallpaper/WallpaperWindow.vala"
		break;
#line 804 "WallpaperWindow.c"
	}
}

